<template>
    <v-row>
        <v-col>
            <v-card>
                <v-container class="pa-5">
                    <v-row>
                        <v-card flat class="transparent">
                            <v-card-title class="text--secondary">{{ $t('member') }}</v-card-title>
                        </v-card>
                    </v-row>

                    <v-row>
                        <v-col cols="4">
                            <v-menu
                                v-model="dateMenu"
                                :close-on-content-click="false"
                                transition="scale-transition"
                                min-width="290px"
                            >
                                <template v-slot:activator="{ on, attrs }">
                                    <v-text-field
                                        v-model="filterDate"
                                        prepend-icon="mdi-calendar"
                                        v-bind="attrs"
                                        v-on="on"
                                        readonly
                                        hide-details
                                        outlined
                                    ></v-text-field>
                                </template>
                                <v-date-picker
                                    type="month"
                                    v-model="filterDate"
                                    @input="dateMenu = false"
                                    @change="onDateChange"
                                >
                                </v-date-picker>
                            </v-menu>
                        </v-col>
                    </v-row>

                    <v-row>
                        <v-col>
                            <v-data-table
                                :headers="headers"
                                :items="items"
                                item-key="affiliate_id"
                                :single-expand="true"
                                :loading="loading"
                                :loading-text="$t('loading')"
                            >
                                <template v-slot:item="{ item, expand, isExpanded }">
                                    <tr @click="!!item.children.length && expand(!isExpanded)">
                                        <td>{{ $t('level') }} {{ item.level }}</td>
                                        <td>{{ item.user.profile.name }}</td>
                                        <td>{{ item.user.email }}</td>
                                        <td>{{ item.user.profile.mobile }}</td>
                                        <td class="text-right">{{ item.commission | currency }} MYR</td>
                                        <td class="text-right">{{ item.total_member }}</td>
                                        <td class="text-right">{{ item.commission_sum | currency }} MYR</td>
                                        <td>
                                            <v-btn icon>
                                                <v-icon
                                                    small
                                                    @click.stop="openDialog(item)"
                                                >
                                                    mdi-pencil
                                                </v-icon>
                                            </v-btn>
                                        </td>
                                        <td>
                                            <v-icon v-if="!!item.children.length">keyboard_arrow_down</v-icon>
                                        </td>
                                    </tr>
                                </template>

                                <template v-slot:no-data>
                                    {{ $t('no_data') }}
                                </template>

                                <template v-slot:no-results>
                                    {{ $t('no_result') }}
                                </template>

                                <template v-slot:expanded-item="{ headers, item }">
                                    <td :colspan="headers.length">
                                        <v-container>
                                            <v-row justify="center">
                                                <v-col>
                                                    <v-treeview
                                                        class="tree elevation-2"
                                                        :items="item.children"
                                                        item-key="affiliate_id"
                                                        :open-on-click="true"
                                                    >
                                                        <template v-slot:label="{ item }">
                                                            <v-row class="tree-item" no-gutters>
                                                                <v-col>{{ $t('level' )}} {{ item.level }}</v-col>
                                                                <v-col>{{ item.user.profile.name }}</v-col>
                                                                <v-col>{{ item.user.email }}</v-col>
                                                                <v-col>{{ item.user.profile.mobile }}</v-col>
                                                                <v-col class="text-right">{{ item.commission | currency }} MYR</v-col>
                                                                <v-col class="text-right">{{ item.total_member }}</v-col>
                                                                <v-col class="text-right">{{ item.commission_sum | currency }} MYR</v-col>
                                                            </v-row>
                                                        </template>

                                                        <template v-slot:append="{ item }">
                                                            <v-btn class="ml-4" icon>
                                                                <v-icon
                                                                    small
                                                                    @click.stop="openDialog(item)"
                                                                >
                                                                    mdi-pencil
                                                                </v-icon>
                                                            </v-btn>
                                                        </template>
                                                    </v-treeview>
                                                </v-col>
                                            </v-row>
                                        </v-container>
                                    </td>
                                </template>
                            </v-data-table>
                        </v-col>
                    </v-row>
                </v-container>
            </v-card>
        </v-col>

        <v-dialog
            v-model="dialog"
            persistent
            max-width="400"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('member_commission') }}
                </v-card-title>

                <v-card-text class="pt-5">
                    <p class="mb-2">{{ $t('member_commission_desc_1') }}</p>
                    <p class="mb-0">{{ $t('member_commission_desc_2') }}</p>

                    <v-container>
                        <v-row>
                            <v-col>
                                <div class="field-label">{{ $t('commission') }}</div>
                                <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                                    <ValidationProvider v-slot="{ errors }" name="commission" rules="min_value:0|decimal">
                                        <v-text-field
                                            v-if="editing !== null"
                                            v-model="editing.commission"
                                            type="number"
                                            :error-messages="errors"
                                            hide-details="auto"
                                            outlined
                                        >
                                        </v-text-field>
                                    </ValidationProvider>
                                </ValidationObserver>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-card-text>

                <v-card-actions class="justify-center pa-5">
                    <v-btn
                        class="error"
                        color="white"
                        @click="closeDialog"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        class="primary"
                        color="white"
                        :loading="submit"
                        @click="updateCommission"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import moment from "moment";
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import DataTable from "../DataTable";
    import permission from "../../../mixins/permission";

    export default {
        name: "Member",
        components: {DataTable, ValidationObserver, ValidationProvider},
        mixins: [permission],
        data: () => ({
            items: [],
            loading: false,
            submit: false,
            dialog: false,
            editing: null,
            dateMenu: false,
            filterDate: moment().format('YYYY-MM'),
        }),
        computed: {
            endpoint() {
                return this.is('admin') ? 'api/affiliates/member' : 'api/affiliate/member'
            },

            headers() {
                return [
                    { text: '#', value: 'level', sortable: false},
                    { text: this.$t('name'), value: 'user.name', sortable: false},
                    { text: this.$t('email'), value: 'user.email', sortable: false },
                    { text: this.$t('mobile'), value: 'user.mobile', sortable: false },
                    { text: this.$t('commission'), value: 'commission', align: 'right' },
                    { text: this.$t('total_member'), value: 'total_member', align: 'right' },
                    { text: this.$t('total_sales'), value: 'commission_sum', align: 'right' },
                    { text: this.$t('action'), value: 'action', sortable: false },
                    { text: '', value: 'expand-icon', sortable: false },
                ]
            }
        },
        mounted() {
            this.getDataFromApi()
                .then(({ data }) => {
                    this.items = data;
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                })
        },
        methods: {
            onDateChange() {
                this.getDataFromApi()
                    .then(({ data }) => {
                        this.items = data;
                        this.loading = false;
                    })
                    .catch(() => {
                        this.loading = false;
                    })
            },

            openDialog(item) {
                this.editing = item;
                this.dialog = true;
            },

            closeDialog() {
                this.dialog = false;
                this.editing = null;
            },

            getDataFromApi() {
                this.loading = true;

                return new Promise((resolve, reject) => {
                    axios.get(this.endpoint, {
                        params: {
                            date: this.filterDate
                        }
                    })
                        .then(response => {
                            resolve(response.data);
                        })
                        .catch(error => {
                            reject(error.response.data);
                        })
                })
            },

            updateCommission() {
                this.submit = true;

                this.callUpdateCommissionApi()
                    .then(data => {
                        this.submit = false;
                        if(data) {
                            this.dialog = false;
                            this.editing = null;
                        }
                    })
                    .catch(error => {
                        this.$refs.observer.setErrors(error.errors);
                        this.submit = false;
                    })
            },

            callUpdateCommissionApi() {
                return new Promise((resolve, reject) => {
                    axios.put('api/affiliate/member/commission/'+ this.editing.affiliate_id, {
                        commission: this.editing.commission
                    })
                        .then(response => {
                            resolve(response.data);
                        })
                        .catch(error => {
                            reject(error.response.data);
                        })
                })
            }
        }
    }
</script>

<style scoped>
    .tree >>> .v-treeview-node:nth-of-type(even) {
        background-color: #f2f2f2;
    }

    .tree-item {
        font-family: Roboto, sans-serif;
        font-size: 14px;
    }
</style>
